BasicDesktopPaneUI (Java Platform SE 8 )
Keywords: javax.swing.plaf.basic.BasicDesktopPaneUI class
Date: 2018-03-02

javax.swing.plaf.basic

## Class BasicDesktopPaneUI

- java.lang.Object
- - javax.swing.plaf.ComponentUI
  - - javax.swing.plaf.DesktopPaneUI
    - - javax.swing.plaf.basic.BasicDesktopPaneUI

- Direct Known Subclasses:
    SynthDesktopPaneUI

      public class BasicDesktopPaneUI
      extends DesktopPaneUI

  Basic L&F for a desktop.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `BasicDesktopPaneUI.CloseAction` Handles closing an internal frame.
    `protected class` | `BasicDesktopPaneUI.MaximizeAction` Handles maximizing an internal frame.
    `protected class` | `BasicDesktopPaneUI.MinimizeAction` Handles minimizing an internal frame.
    `protected class` | `BasicDesktopPaneUI.NavigateAction` Handles navigating to the next internal frame.
    `protected class` | `BasicDesktopPaneUI.OpenAction` Handles restoring a minimized or maximized internal frame.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected KeyStroke` | `closeKey` Deprecated. As of 1.3.
    `protected JDesktopPane` | `desktop`
    `protected DesktopManager` | `desktopManager`
    `protected KeyStroke` | `maximizeKey` Deprecated. As of 1.3.
    `protected KeyStroke` | `minimizeKey` Deprecated. As of 1.3.
    `protected KeyStroke` | `navigateKey` Deprecated. As of 1.3.
    `protected KeyStroke` | `navigateKey2` Deprecated. As of 1.3.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BasicDesktopPaneUI()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected PropertyChangeListener` | `createPropertyChangeListener()` Returns the `PropertyChangeListener` to install on the `JDesktopPane`.
    `static ComponentUI` | `createUI(JComponent c)`
    `Dimension` | `getMaximumSize(JComponent c)` Returns the specified component's maximum size appropriate for the look and feel.
    `Dimension` | `getMinimumSize(JComponent c)` Returns the specified component's minimum size appropriate for the look and feel.
    `Dimension` | `getPreferredSize(JComponent c)` Returns the specified component's preferred size appropriate for the look and feel.
    `protected void` | `installDefaults()`
    `protected void` | `installDesktopManager()`
    `protected void` | `installKeyboardActions()`
    `protected void` | `installListeners()` Installs the `PropertyChangeListener` returned from `createPropertyChangeListener` on the `JDesktopPane`.
    `void` | `installUI(JComponent c)` Configures the specified component appropriately for the look and feel.
    `void` | `paint(Graphics g, JComponent c)` Paints the specified component appropriately for the look and feel.
    `protected void` | `registerKeyboardActions()`
    `protected void` | `uninstallDefaults()`
    `protected void` | `uninstallDesktopManager()`
    `protected void` | `uninstallKeyboardActions()`
    `protected void` | `uninstallListeners()` Uninstalls the `PropertyChangeListener` returned from `createPropertyChangeListener` from the `JDesktopPane`.
    `void` | `uninstallUI(JComponent c)` Reverses configuration which was done on the specified component during `installUI`.
    `protected void` | `unregisterKeyboardActions()`

    - ### Methods inherited from class javax.swing.plaf.ComponentUI

      `contains, getAccessibleChild, getAccessibleChildrenCount, getBaseline, getBaselineResizeBehavior, update`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### desktop

          protected JDesktopPane desktop

    - #### desktopManager

          protected DesktopManager desktopManager

    - #### minimizeKey

          @Deprecated
          protected KeyStroke minimizeKey

      Deprecated. As of 1.3.
      As of Java 2 platform v1.3 this previously undocumented field is no longer used. Key bindings are now defined by the LookAndFeel, please refer to the key bindings specification for further details.

    - #### maximizeKey

          @Deprecated
          protected KeyStroke maximizeKey

      Deprecated. As of 1.3.
      As of Java 2 platform v1.3 this previously undocumented field is no longer used. Key bindings are now defined by the LookAndFeel, please refer to the key bindings specification for further details.

    - #### closeKey

          @Deprecated
          protected KeyStroke closeKey

      Deprecated. As of 1.3.
      As of Java 2 platform v1.3 this previously undocumented field is no longer used. Key bindings are now defined by the LookAndFeel, please refer to the key bindings specification for further details.

    - #### navigateKey

          @Deprecated
          protected KeyStroke navigateKey

      Deprecated. As of 1.3.
      As of Java 2 platform v1.3 this previously undocumented field is no longer used. Key bindings are now defined by the LookAndFeel, please refer to the key bindings specification for further details.

    - #### navigateKey2

          @Deprecated
          protected KeyStroke navigateKey2

      Deprecated. As of 1.3.
      As of Java 2 platform v1.3 this previously undocumented field is no longer used. Key bindings are now defined by the LookAndFeel, please refer to the key bindings specification for further details.

  - ### Constructor Detail

    - #### BasicDesktopPaneUI

          public BasicDesktopPaneUI()

  - ### Method Detail

    - #### createUI

          public static ComponentUI createUI(JComponent c)

    - #### installUI

          public void installUI(JComponent c)

      Description copied from class: `ComponentUI`
      Configures the specified component appropriately for the look and feel. This method is invoked when the `ComponentUI` instance is being installed as the UI delegate on the specified component. This method should completely configure the component for the look and feel, including the following:
      1. Install default property values for color, fonts, borders, icons, opacity, etc. on the component. Whenever possible, property values initialized by the client program should not be overridden.
      2. Install a `LayoutManager` on the component if necessary.
      3. Create/add any required sub-components to the component.
      4. Create/install event listeners on the component.
      5. Create/install a `PropertyChangeListener` on the component in order to detect and respond to component property changes appropriately.
      6. Install keyboard UI (mnemonics, traversal, etc.) on the component.
      7. Initialize any appropriate instance data.
      Overrides:
        `installUI` in class `ComponentUI`
      Parameters:
        `c` - the component where this UI delegate is being installed
      See Also:
        `ComponentUI.uninstallUI(javax.swing.JComponent)`, `JComponent.setUI(javax.swing.plaf.ComponentUI)`, `JComponent.updateUI()`

    - #### uninstallUI

          public void uninstallUI(JComponent c)

      Description copied from class: `ComponentUI`
      Reverses configuration which was done on the specified component during `installUI`. This method is invoked when this `UIComponent` instance is being removed as the UI delegate for the specified component. This method should undo the configuration performed in `installUI`, being careful to leave the `JComponent` instance in a clean state (no extraneous listeners, look-and-feel-specific property objects, etc.). This should include the following:
      1. Remove any UI-set borders from the component.
      2. Remove any UI-set layout managers on the component.
      3. Remove any UI-added sub-components from the component.
      4. Remove any UI-added event/property listeners from the component.
      5. Remove any UI-installed keyboard UI from the component.
      6. Nullify any allocated instance data objects to allow for GC.
      Overrides:
        `uninstallUI` in class `ComponentUI`
      Parameters:
        `c` - the component from which this UI delegate is being removed; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      See Also:
        `ComponentUI.installUI(javax.swing.JComponent)`, `JComponent.updateUI()`

    - #### installDefaults

          protected void installDefaults()

    - #### uninstallDefaults

          protected void uninstallDefaults()

    - #### installListeners

          protected void installListeners()

      Installs the `PropertyChangeListener` returned from `createPropertyChangeListener` on the `JDesktopPane`.
      Since:
        1.5
      See Also:
        `createPropertyChangeListener()`

    - #### uninstallListeners

          protected void uninstallListeners()

      Uninstalls the `PropertyChangeListener` returned from `createPropertyChangeListener` from the `JDesktopPane`.
      Since:
        1.5
      See Also:
        `createPropertyChangeListener()`

    - #### installDesktopManager

          protected void installDesktopManager()

    - #### uninstallDesktopManager

          protected void uninstallDesktopManager()

    - #### installKeyboardActions

          protected void installKeyboardActions()

    - #### registerKeyboardActions

          protected void registerKeyboardActions()

    - #### unregisterKeyboardActions

          protected void unregisterKeyboardActions()

    - #### uninstallKeyboardActions

          protected void uninstallKeyboardActions()

    - #### paint

          public void paint(Graphics g,
                            JComponent c)

      Description copied from class: `ComponentUI`
      Paints the specified component appropriately for the look and feel. This method is invoked from the `ComponentUI.update` method when the specified component is being painted. Subclasses should override this method and use the specified `Graphics` object to render the content of the component.
      Overrides:
        `paint` in class `ComponentUI`
      Parameters:
        `g` - the `Graphics` context in which to paint
        `c` - the component being painted; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      See Also:
        `ComponentUI.update(java.awt.Graphics, javax.swing.JComponent)`

    - #### getPreferredSize

          public Dimension getPreferredSize(JComponent c)

      Description copied from class: `ComponentUI`
      Returns the specified component's preferred size appropriate for the look and feel. If `null` is returned, the preferred size will be calculated by the component's layout manager instead (this is the preferred approach for any component with a specific layout manager installed). The default implementation of this method returns `null`.
      Overrides:
        `getPreferredSize` in class `ComponentUI`
      Parameters:
        `c` - the component whose preferred size is being queried; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      See Also:
        `JComponent.getPreferredSize()`, `LayoutManager.preferredLayoutSize(java.awt.Container)`

    - #### getMinimumSize

          public Dimension getMinimumSize(JComponent c)

      Description copied from class: `ComponentUI`
      Returns the specified component's minimum size appropriate for the look and feel. If `null` is returned, the minimum size will be calculated by the component's layout manager instead (this is the preferred approach for any component with a specific layout manager installed). The default implementation of this method invokes `getPreferredSize` and returns that value.
      Overrides:
        `getMinimumSize` in class `ComponentUI`
      Parameters:
        `c` - the component whose minimum size is being queried; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      Returns:
        a `Dimension` object or `null`
      See Also:
        `JComponent.getMinimumSize()`, `LayoutManager.minimumLayoutSize(java.awt.Container)`, `ComponentUI.getPreferredSize(javax.swing.JComponent)`

    - #### getMaximumSize

          public Dimension getMaximumSize(JComponent c)

      Description copied from class: `ComponentUI`
      Returns the specified component's maximum size appropriate for the look and feel. If `null` is returned, the maximum size will be calculated by the component's layout manager instead (this is the preferred approach for any component with a specific layout manager installed). The default implementation of this method invokes `getPreferredSize` and returns that value.
      Overrides:
        `getMaximumSize` in class `ComponentUI`
      Parameters:
        `c` - the component whose maximum size is being queried; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      Returns:
        a `Dimension` object or `null`
      See Also:
        `JComponent.getMaximumSize()`, `LayoutManager2.maximumLayoutSize(java.awt.Container)`

    - #### createPropertyChangeListener

          protected PropertyChangeListener createPropertyChangeListener()

      Returns the `PropertyChangeListener` to install on the `JDesktopPane`.
      Returns:
        The PropertyChangeListener that will be added to track changes in the desktop pane.
      Since:
        1.5

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2018, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.